#!/bin/bash
#set -n		# read but do not execute commands (check on syntax errors)
#
# File: /usr/local/bin/mediaconcat
#
# Concatenate multiple audio files together.
#
#    Copyright (c) 2025  Juergen Kaesmann (JK)
#
##############################################################################
# GPL NOTICE
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
##############################################################################
# FIND SAMPLES
#
##############################################################################
# FILTER SAMPLES
#
##############################################################################
# AWK SAMPLES
#
##############################################################################
# SED SAMPLES
#
##############################################################################
# RSYNC OPTIONS
#
##############################################################################
# DIALOG SAMPLES
#
##############################################################################
# REPLACE STRINGS
#
##############################################################################
# EXIT CODES

##############################################################################
# SOURCE FILES
#
. /usr/local/etc/main.conf				# config main
#. $LLIBDIR/libfuncerr-sh				# functions error
. $LLIBDIR/libfuncstd-sh				# functions standard
#. $LLIBDIR/libfuncmath-sh				# functions math
#. $LLIBDIR/libfuncip-sh				# functions IP
#. /usr/local/etc/sample.conf				# config sample

#if [ ! -e ~/.samplerc ]; then				# install config user
#	cp /usr/local/share/ksm-sample/samplerc ~/.samplerc
#	echo "Please configure your ~/.samplerc"
#	exit 1
#fi
#. ~/.samplerc						# config user

##############################################################################
# DECLARATION OF STANDARD CONSTANTS AND VARIABLES
#
readonly package=Multimedia				# package name
readonly package_file=ksm-multimedia			# package file name
readonly vinfopath="/usr/local/share/$package_file"	# path to package dir
readonly version=$(/bin/cat $vinfopath/VERSION)		# package version
readonly release=$(/bin/cat $vinfopath/RELEASE)		# package release
readonly scriptname=$(basename $0)			# name of script
readonly tempfile=$TEMPDIR/$scriptname.$UID.tmp		# temporary file name
#tempfile=$(mktemp $TEMPDIR/$scriptname.$UID.XXXXXX)	# temporary file name
#readonly lockfile=$TEMPDIR/lock/$scriptname.$UID.lock	# lock file name
readonly debuglog="/usr/bin/logger -p user.debug -t $scriptname -- DEBUG:"	# log dbg msg
readonly errlog="/usr/bin/logger -p user.err -t $scriptname -- ERROR:"		# log err msg
readonly infolog="/usr/bin/logger -p user.info -t $scriptname -- INFO:"		# log inf msg
cmd=''							# sub command
debug=no						# debug=yes/no
verbose=''						# verbose=yes/''/no
err=${_ERR_OK_}						# error code

##############################################################################
# USER FILL IN AT FIRST RUN

##############################################################################
# SYSTEM

##############################################################################
# USER-CONSTANTS

##############################################################################
# USER-VARIABLES
#
# STRINGS
tempts1=/tmp/$scriptname.$UID.1.ts	# temporary file name in fn concat
tempts2=/tmp/$scriptname.$UID.2.ts	# temporary file name in fn concat
t1=''					# temporary file name
t2=''					# temporary file name
outfile='fin.m4a'			# default output file name

#args=''				# all args from cmdline
arg1=''					# 1. arg from cmdline
#opt_o=''				# option -o (yes)
					# option --output (yes)
#opt_i=''				# option -i (arg)
					# option --infile (arg)
opt_o=''				# option -o (arg)
					# option --outfile (arg)
#opt_p=''				# option -p (arg)
					# option --pages (arg)
ext=''

# NUMBERS
#p_first=0				# first page
#p_last=0				# last page

# ARRAYS
# Indexed arrays are always zero based string arrays.
# If index starts with 1 and all members are assigned then
# count of members of array = last index of array
#declare -a arr
#maxarr="${#arr[@]}"			# get number of elements in arr
#unset arr[@]				# remove the entire array

##############################################################################
# SIGNAL HANDLING

##############################################################################
# FUNCTIONS
##############################################################################
#
##############################################################################
# HELP
#
#=============================================================================
function helptext ()
{
# Output helptext
# Uses cat, echo, logger
# Return codes:
# Standard

if [ "$debug" == "yes" ]; then				# DEBUG
	echo "DEBUG helptext: $# $@" >&2
	$debuglog helptext: $# $@
fi

cat <<EOT
NAME
$scriptname - Concatenate multiple audio files together.

SYNOPSIS
$scriptname [options] [inf inf ...]

DESCRIPTION
Concatenate multiple audio files (WAV or AAC) together. At least two
input files must be given. Concatenation is done in the same order as
they are given.

All input files has to be of type WAV (.wav) or AAC (.m4a). In addition
all input files must have only one audio stream. The output media file
will always be of type AAC (.m4a).

Defaults:  Use output file name $outfile

OPTIONS
Gnu style options:

  -h|--help    = Output help, then exit.
  -V|--version = Output version info, then exit.
  -d|--debug   = Turn on DEBUG mode.
  -q|--quiet   = Be quiet.
  -v|--verbose = Be verbose.
  -o f         = Output to file <f> (AAC .m4a).
  --outfile=f  = Output to file <f> (AAC .m4a).
  --           = End of options.

ARGUMENTS
Give if needed:

  inf = An wav file for concatenation.

EXIT STATUS
On program exit:

  Code 0 = OK

  See output of 'showerrmsg'.

SEE ALSO
Related manpages:

  showerrmsg(1), ffmpeg(1), media2media(1).

AUTHORS
Juergen Kaesmann <juergen@kaesmann-online.de>
EOT
#  -o|--output  = Output to STDOUT.
#  -i f         = Input from file <f>.
#  --infile=f   = Input from file <f>.
#  -o f         = Output to file <f>.
#  --outfile=f  = Output to file <f>.
#  -p s,e       = Pages s=START e=END.
#  --pages=s,e  = Pages s=START e=END.

#EXAMPLES
#For instance:
#
#  Do it:
#  $scriptname

#FILES
#Used directories and files:
#
#  Config Global = /usr/local/etc/sample.conf
#  Config User   = ~/.samplerc

return
}

#=============================================================================
function concat ()
{
# Concat 2 files together.
# par1 = infile
# par2 = infile
# par3 = outfile
# Uses echo, ffmpeg, logger
# Return codes:
# Standard

if [ "$debug" == "yes" ]; then				# DEBUG
	echo "DEBUG concat: $# $@" >&2
	$debuglog concat: $# $@
fi

local f1="$1" f2="$2" of="$3" ext1='' ext2='' ext3=''
local ret=0

ext1=${outfile##*.}
ext2=${1##*.}
ext3=${2##*.}
if [ "$ext1" != "m4a" ]; then
	if [ "$verbose" != no ]; then
		echo "${ErrMsg[11]} extension of output file is not .m4a" >&2
	else
		$errlog ${ErrMsg[11]} extension of output file is not .m4a
	fi
	exit 11
fi
if [ "$ext2" != "$ext3" ]; then
	if [ "$verbose" != no ]; then
		echo "${ErrMsg[11]} Unequal extensions of input files." >&2
	else
		$errlog ${ErrMsg[11]} Unequal extensions of input files.
	fi
	exit 11
fi

case "$ext2" in
    wav)
	case "$verbose" in
	    yes)
		# allow STDOUT and STDERR
		echo "Append $f2"
		# change mpg to ts, keep streams
		ffmpeg -y -i $f1 -c aac -f mpegts $tempts1
		ffmpeg -y -i $f2 -c aac -f mpegts $tempts2

		# concat both ts to output file with all streams from concatenation
		#ffmpeg -hide_banner -y -i "concat:$tempts1|$tempts2" -c pcm_s16le $of
		ffmpeg -y -i "concat:$tempts1|$tempts2" -c copy $of
		ret=$?
		;;
	    '')
		echo "Append $f2"
		# suppress STDERR
		# change mpg to ts, keep streams
		ffmpeg -hide_banner -y -i $f1 -c aac -f mpegts $tempts1 2>/dev/null
		ffmpeg -hide_banner -y -i $f2 -c aac -f mpegts $tempts2 2>/dev/null

		# concat both ts to output file with all streams from concatenation
		#ffmpeg -hide_banner -y -i "concat:$tempts1|$tempts2" -c pcm_s16le $of 2>/dev/null
		ffmpeg -hide_banner -y -i "concat:$tempts1|$tempts2" -c copy $of 2>/dev/null
		ret=$?
		;;
	    no)
		# suppress STDOUT and STDERR
		# concat both ts to output file with all streams from concatenation
		# change mpg to ts, keep streams
		ffmpeg -hide_banner -y -i $f1 -c aac -f mpegts $tempts1 &>/dev/null
		ffmpeg -hide_banner -y -i $f2 -c aac -f mpegts $tempts2 &>/dev/null

		# concat both ts to output file with all streams from concatenation
		#ffmpeg -hide_banner -y -i "concat:$tempts1|$tempts2" -c pcm_s16le $of &>/dev/null
		ffmpeg -hide_banner -y -i "concat:$tempts1|$tempts2" -c copy $of &>/dev/null
		ret=$?
		;;
	esac
	;;
    m4a)
	case "$verbose" in
	    yes)
		# allow STDOUT and STDERR
		echo "Append $f2"
		# change mpg to ts, keep streams
		ffmpeg -y -i $f1 -c copy -f mpegts $tempts1
		ffmpeg -y -i $f2 -c copy -f mpegts $tempts2

		# concat both ts to output file with all streams from concatenation
		#ffmpeg -hide_banner -y -i "concat:$tempts1|$tempts2" -c pcm_s16le $of
		ffmpeg -y -i "concat:$tempts1|$tempts2" -c copy $of
		ret=$?
		;;
	    '')
		echo "Append $f2"
		# suppress STDERR
		# change mpg to ts, keep streams
		ffmpeg -hide_banner -y -i $f1 -c copy -f mpegts $tempts1 2>/dev/null
		ffmpeg -hide_banner -y -i $f2 -c copy -f mpegts $tempts2 2>/dev/null

		# concat both ts to output file with all streams from concatenation
		#ffmpeg -hide_banner -y -i "concat:$tempts1|$tempts2" -c pcm_s16le $of 2>/dev/null
		ffmpeg -hide_banner -y -i "concat:$tempts1|$tempts2" -c copy $of 2>/dev/null
		ret=$?
		;;
	    no)
		# suppress STDOUT and STDERR
		# concat both ts to output file with all streams from concatenation
		# change mpg to ts, keep streams
		ffmpeg -hide_banner -y -i $f1 -c copy -f mpegts $tempts1 &>/dev/null
		ffmpeg -hide_banner -y -i $f2 -c copy -f mpegts $tempts2 &>/dev/null

		# concat both ts to output file with all streams from concatenation
		#ffmpeg -hide_banner -y -i "concat:$tempts1|$tempts2" -c pcm_s16le $of &>/dev/null
		ffmpeg -hide_banner -y -i "concat:$tempts1|$tempts2" -c copy $of &>/dev/null
		ret=$?
		;;
	esac
	;;
    *)
	echo "Unknown container $ext2"
	;;
esac
rm -f $tempts1
rm -f $tempts2

if [ "$ret" -ne 0 ]; then
	if [ "$verbose" != no ]; then
		echo "${ErrMsg[${_ERR_GENERAL_}]} $ret from ffmpeg concat!" >&2
	else
		$errlog ${ErrMsg[${_ERR_GENERAL_}]} $ret from ffmpeg concat!
	fi
	ret=${_ERR_GENERAL_}
fi

return $ret
}

#=============================================================================
function mainproc ()
{
# Concat all files together.
# pars = all pars
# Uses cp, echo, logger, mv, rm
# Return codes:
# Standard

if [ "$debug" == "yes" ]; then				# DEBUG
	echo "DEBUG mainproc: $# $@" >&2
	$debuglog mainproc: $# $@
fi

local ret=0
#local -a arr
#maxarr="${#arr[@]}"			# get number of elements in arr
#unset arr[@]				# remove the entire array

if [ -e "$1" ]; then
	cp $1 $t1
	shift
else
	ret=5
	if [ "$verbose" != no ]; then
		echo "$scriptname ${ErrMsg[${ret}]} $1" >&2
	else
		$errlog $scriptname ${ErrMsg[${ret}]} $1
	fi
fi

while [ "$ret" -eq 0 ] && [ $# -gt 0 ]; do
	if [ -e "$1" ]; then
		concat $t1 $1 $t2
		ret=$?
		shift
		if [ "$ret" -eq 0 ]; then
			mv $t2 $t1
		fi
	else
		ret=5
		if [ "$verbose" != no ]; then
			echo "$scriptname ${ErrMsg[${ret}]} $1" >&2
		else
			$errlog $scriptname ${ErrMsg[${ret}]} $1
		fi
	fi
done
if [ "$ret" -eq 0 ]; then
	cp $t1 $outfile
fi

return $ret
}

##############################################################################
# GET OPTIONS
##############################################################################
# Give 2 strings and all cmdline_args to func GetOpt
# (POSIX_options Gnu_long_options cmdline_args):
# GetOpt 'hVdqvi:m:' 'help version debug quiet verbose infile= myval=' $@
#
# A ':' after a POSIX option means this option needs an arg.
# A '=' after a Gnu long option means this option needs an arg.
#
# All cmd/options have to be initialised to ''!
#
# Options are divided in 2 classes:
#   a) cmds (mutually exclusive). All cmds are given to var 'cmd'.
#   b) options (as many as you like). Each option is given to it's own var.
# As a general rule: If cmds/options are given multiple then last given wins.
#
# Options can take 1 argument (no whitespace in arg). If you want to give more
# than 1 arg or want to use multiple strings as 1 arg then concatenate them
# together with a delimiter like ',' or ';' or '.'
# Use a delimiter which will not be part of the arg:
# sampleprog -m val1,val2
# sampleprog --myval=val1,val2
# It's at the programmers responsibility to do meaningfull things with the
# content of the options.
#
# While err = 0 then look for a next option.
# When GetOpt finishes then all options are removed from cmdline.
#
if [ "$debug" == "yes" ]; then				# DEBUG
	echo "DEBUG Parse Commandline: $# $@" >&2
	$debuglog Parse Commandline: $# $@
fi
#
err=0
while [ "$err" -eq 0 ]; do
	GetOpt 'hVdqvo:' 'help version debug quiet verbose outfile=' $@
	err=$?
	#echo "DEBUG GET OPTIONS: err=${err}  _OPTNAME_=${_OPTNAME_}  _OPTVAL_=${_OPTVAL_}  _OPTPOS_=${_OPTPOS_}  _OPTIDX_=${_OPTIDX_}" >&2
	if [ $err -eq 0 ]; then
		case "$_OPTNAME_" in
		    h|help)	cmd="-h";;
		    V|version)	cmd="-V";;
#		    a)		cmd="-${_OPTNAME_}";;
		    d|debug)	debug=yes;;
		    q|quiet)	verbose=no;;
		    v|verbose)	verbose=yes;;
#		    o|output)	opt_o=yes;;
#		    i|infile)	opt_i="${_OPTVAL_}";;
		    o|outfile)	opt_o="${_OPTVAL_}";;
#		    p|pages)	opt_p="${_OPTVAL_}";;
		    --)		break;;
		    :)	if [ "$verbose" != no ]; then
				echo "${ErrMsg[8]} -${_OPTVAL_}" >&2
			else
				$errlog ${ErrMsg[8]} -${_OPTVAL_}
			fi; exit 8;;
		    ?)	if [ "$verbose" != no ]; then
				echo "${ErrMsg[4]} -${_OPTVAL_}" >&2
			else
				$errlog ${ErrMsg[4]} -${_OPTVAL_}
			fi; exit 4;;
		    *)	if [ "$verbose" != no ]; then
				echo "${ErrMsg[99]} _OPTNAME_=${_OPTNAME_} _OPTVAL_=${_OPTVAL_}" >&2
			else
				$errlog ${ErrMsg[99]} _OPTNAME_=${_OPTNAME_} _OPTVAL_=${_OPTVAL_}
			fi; exit 99;;
		esac
	fi
done
err=0
shift ${_OPTIDX_}				# rm all opts from cmdline
# Uncomment if giving a cmd is mandatory
#if [ -z "$cmd" ]; then					# error no cmd given
#	if [ "$verbose" != no ]; then
#		echo "${ErrMsg[7]}" >&2
#	else
#		$errlog ${ErrMsg[7]}
#	fi
#	exit 7
#fi

##############################################################################
# CHECK LINK NAMES

##############################################################################
# CHECK OPTIONS

##############################################################################
# CHECK VERSION

##############################################################################
# CHECK ARGUMENTS
#
case "$cmd" in
    '')
	if [ "$#" -ge 2 ]; then				# parameter count ok
		#arg1="$1"
		#shift
		args="$@"
		shift $#
	else						# error in param count
		if [ "$verbose" != no ]; then
			echo "${ErrMsg[2]}" >&2
		else
			$errlog ${ErrMsg[2]}
		fi
		exit 2
	fi
	;;
    *)
	if [ "$#" -ne 0 ]; then				# error in param count
		if [ "$verbose" != no ]; then
			echo "${ErrMsg[2]}" >&2
		else
			$errlog ${ErrMsg[2]}
		fi
		exit 2
	fi
	;;
esac

##############################################################################
# LOCK

##############################################################################
# MAINPROGRAM
##############################################################################
#
if [ "$debug" == "yes" ]; then				# DEBUG
	echo "DEBUG Main: $# $@" >&2
	$debuglog Main: $# $@
fi

# Check what to do (sub commands, options and args are removed from cmdline)
case "$cmd" in
    '')
	if [ -n "$opt_o" ]; then
		outfile="$opt_o"
	fi
	ext=${args##*.}
	t1="/tmp/$scriptname.$UID.1.${ext}"		# temporary file name
	t2="/tmp/$scriptname.$UID.2.${ext}"		# temporary file name
	mainproc $args
	err=$?
	rm -f $t1
	rm -f $t2
	;;
    -h)
	helptext
	exit 0
	;;
    -V)
	echo "${scriptname}: (${package}) $package_file ${version}-${release}"
	exit 0
	;;
    *)							# error
	if [ "$verbose" != no ]; then
		echo "${ErrMsg[6]}" >&2
	else
		$errlog ${ErrMsg[6]}
	fi
	err=6
	;;
esac

#rm -f $lockfile

exit $err
